function Status() {
    "use strict";

    var initialMoney = 0;
    var initialMinimum = 0;
    var initialCustomers = 0;
    var initialminimum = 0;
    var initialCapacity = 20;

    var initialShoutStrength = 1;
    var initialCustomerGain = 2;
    var initialCapacityGain = 20;
    var initialDecayRateDecline = 0.2;
    var initialCustomerWealthGain = 1;
    var initialCustomerBuyRateGain = 0.1;
    var initialShoutStrengthGain = 1;

    var initialCustomerDecayRate = 2;
    var initialCustomerBuyRate = 0.05;
    var initialCustomerWealth = 2.5;
    var customerDecayRate = initialCustomerDecayRate;
    var customerBuyRate = initialCustomerBuyRate;

    var initialLoyalCustomers = 0;
    var initialNewTotalCustomers = 0;
    var initialNewTotalMoney = 0;
    this.totalLoyalCustomers = 0;
    this.loyalCustomers = 0;
    this.totalMoney = 0;
    this.newTotalMoney = 0;
    this.totalCustomers = 0;
    this.newTotalCustomers = 0;

    this.numberOfShopsSold = 0;

    var self = this;

    function calculateSpeedUp() {
        self.speedUp = self.getSpeedUp(self.totalLoyalCustomers - self.loyalCustomers);
        if (RENDER_DEBUG_TEXT) {
            console.log("New speedUp", self.speedUp)
        }
    }
    
    this.getSpeedUp = function(totalLoyalCustomers) {
        var newSpeedUp = 0;
        if (self.speedUp < 10) {
            newSpeedUp = 1 + totalLoyalCustomers * 0.1;
        } else if (self.speedUp >= 10) {
            newSpeedUp = 10 + (totalLoyalCustomers - 90) * 0.002;
        } else {
            newSpeedUp = 1;
        }
        return newSpeedUp;
    }

    this.reset = function () {
        this.money = initialMoney;
        this.minimum = initialMinimum;
        this.customers = initialCustomers;
        this.capacity = initialCapacity;

        this.shoutStrength = initialShoutStrength;
        this.customerGain = initialCustomerGain;
        this.capacityGain = initialCapacityGain;
        this.decayRateDecline = initialDecayRateDecline;
        this.customerWealthGain = initialCustomerWealthGain;
        this.customerBuyRateGain = initialCustomerBuyRateGain;
        this.shoutStrengthGain = initialShoutStrengthGain;

        customerDecayRate = initialCustomerDecayRate;
        customerBuyRate = initialCustomerBuyRate;
        this.customerWealth = initialCustomerWealth;

        this.loyalCustomers = initialLoyalCustomers;
        this.newTotalCustomers = initialNewTotalCustomers;
        this.newTotalMoney = initialNewTotalMoney;

        calculateSpeedUp();
    }

    this.reset();

    this.update = function (deltaTime) {
        deltaTime *= this.speedUp;
        var deltaSec = deltaTime / 1000;

        this.totalCustomers += (deltaSec / this.speedUp * this.customers) / 10;
        this.newTotalCustomers += (deltaSec / this.speedUp * this.customers) / 10;

        if (this.newTotalCustomers > 100) {
            var percentageNewCustomers = this.newTotalCustomers / this.totalCustomers;
            var percentageNewMoney = this.newTotalMoney / this.totalMoney;
            var percentageNewLoyals = this.loyalCustomers / (this.totalLoyalCustomers + 10);
            if (percentageNewCustomers * percentageNewMoney > 0.75) {
                var newLoyals = (this.newTotalCustomers - 100) * 0.01 * (1 - percentageNewLoyals) * (deltaSec / 60);
                if (this.loyalCustomers + newLoyals <= 0.33 * this.newTotalCustomers) {
                    this.loyalCustomers += newLoyals;
                    this.totalLoyalCustomers += newLoyals;
                }
            }
        }

        if (this.customers > this.minimum) {
            this.totalCustomers = Math.max(1, this.totalCustomers);
            this.newTotalCustomers = Math.max(1, this.newTotalCustomers);
            var customerDecline = (customerDecayRate / 100) * this.capacity / this.speedUp;
            this.customers -= deltaSec * customerDecline;

            if (this.customers < this.minimum) {
                this.customers = this.minimum;
            }
        }

        if (this.customers > 0) {
            var buyingCustomers = this.customers * customerBuyRate * deltaSec;
            this.money += buyingCustomers * this.customerWealth;
            this.totalMoney += buyingCustomers * this.customerWealth;
            this.newTotalMoney += buyingCustomers * this.customerWealth;
        }
    };

    this.loadSaveData = function (cookieManager) {
        console.debug("Loading Status");

        var moneyData = cookieManager.getObject("st_money");
        var index = moneyData.indexOf("$");
        this.money = Number(moneyData.substr(0, index));
        moneyData = moneyData.substr(index + 1);
        index = moneyData.indexOf("$");
        this.newTotalMoney = Number(moneyData.substr(0, index));
        moneyData = moneyData.substr(index + 1);
        index = moneyData.indexOf("$");
        this.totalMoney = Number(moneyData.substr(0, index));
        this.numberOfShopsSold = Number(moneyData.substr(index + 1));

        var customerData = cookieManager.getObject("st_customers");
        index = customerData.indexOf("$");
        this.customers = Number(customerData.substr(0, index));
        customerData = customerData.substr(index + 1);
        index = customerData.indexOf("$");
        this.newTotalCustomers = Number(customerData.substr(0, index));
        customerData = customerData.substr(index + 1);
        index = customerData.indexOf("$");
        this.totalCustomers = Number(customerData.substr(0, index));
        customerData = customerData.substr(index + 1);
        index = customerData.indexOf("$");
        this.loyalCustomers = Number(customerData.substr(0, index));
        customerData = customerData.substr(index + 1);
        index = customerData.indexOf("$");
        this.totalLoyalCustomers = Number(customerData.substr(0, index));
        customerData = customerData.substr(index + 1);
        index = customerData.indexOf("$");
        this.customerGain = Number(customerData.substr(0, index));
        this.customerWealth = Number(customerData.substr(index + 1));

        var capacityData = cookieManager.getObject("st_capacity");
        index = capacityData.indexOf("$");
        this.capacity = Number(capacityData.substr(0, index));
        capacityData = capacityData.substr(index + 1);
        index = capacityData.indexOf("$");
        this.minimum = Number(capacityData.substr(0, index));
        this.capacityGain = Number(capacityData.substr(index + 1));

        this.shoutStrength = Number(cookieManager.getObject("st_shoutStrength"));
        this.decayRateDecline = Number(cookieManager.getObject("st_decayRateDecline"));

        this.customerWealthGain = Number(cookieManager
            .getObject("st_customerWealthGain"));
        this.customerBuyRateGain = Number(cookieManager
            .getObject("st_customerBuyRateGain"));
        this.shoutStrengthGain = Number(cookieManager
            .getObject("st_shoutStrengthGain"));

        customerDecayRate = Number(cookieManager.getObject("st_customerDecayRate"));
        customerBuyRate = Number(cookieManager.getObject("st_customerBuyRate"));

        calculateSpeedUp();

        var lastUpdate = Number(cookieManager.getObject("st_lastSave"));
        var delta = new Date().getTime() - lastUpdate;
        console.debug("Time since last login (ms):", delta);
        this.update(delta);
    }

    this.getSaveData = function () {
        var data = [];

        data.push({
            name: "st_money",
            value: Math.floor(this.money) //
                + "$" + Math.floor(this.newTotalMoney) //
                + "$" + Math.floor(this.totalMoney) //
                + "$" + this.numberOfShopsSold
        });
        data.push({
            name: "st_customers",
            value: Math.floor(this.customers) //
                + "$" + Math.floor(this.newTotalCustomers) //
                + "$" + Math.floor(this.totalCustomers) //
                + "$" + Math.floor(this.loyalCustomers) //
                + "$" + Math.floor(this.totalLoyalCustomers) //
                + "$" + Math.floor(this.customerGain) //
                + "$" + Math.floor(this.customerWealth)
        });

        data.push({
            name: "st_capacity",
            value: this.capacity + "$" + this.minimum + "$" + this.capacityGain
        });

        data.push({
            name: "st_shoutStrength",
            value: this.shoutStrength
        });
        data.push({
            name: "st_decayRateDecline",
            value: this.decayRateDecline
        });
        data.push({
            name: "st_customerWealthGain",
            value: this.customerWealthGain
        });
        data.push({
            name: "st_customerBuyRateGain",
            value: this.customerBuyRateGain
        });
        data.push({
            name: "st_shoutStrengthGain",
            value: this.shoutStrengthGain
        });
        data.push({
            name: "st_customerDecayRate",
            value: customerDecayRate
        });
        data.push({
            name: "st_customerBuyRate",
            value: customerBuyRate
        });
        data.push({
            name: "st_lastSave",
            value: new Date().getTime()
        });

        return data;
    }
}

Status.prototype.toString = function () {
    "use strict";

    return "Status";
}